var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { BigNumberString, DecimalString } from "@snickerdoodlelabs/objects";
import { BigNumber, utils } from "ethers";
import { injectable } from "inversify";
let BigNumberUtils = class BigNumberUtils {
    constructor() {
        this.oneBN = utils.parseUnits("1", 18);
    }
    multiply(bn, number) {
        const bnForSure = BigNumber.from(bn);
        const numberBN = utils.parseUnits(number.toString(), 18);
        return bnForSure.mul(numberBN).div(this.oneBN);
    }
    divide(bn, number) {
        const bnForSure = BigNumber.from(bn);
        const numberBN = utils.parseUnits(number.toString(), 18);
        return bnForSure.mul(this.oneBN).div(numberBN);
    }
    /* Conversion from decimal string to big number and big number string */
    DSToBN(decimalString, decimals) {
        return utils.parseUnits(decimalString, decimals || 18);
    }
    DSToBNS(decimalString, decimals) {
        return BigNumberString(utils.parseUnits(decimalString, decimals || 18).toString());
    }
    /* End region of decimal string conversions */
    /* Conversion from big number to big number string and decimal string */
    BNToBNS(bigNumber) {
        return BigNumberString(BigNumber.from(bigNumber).toString());
    }
    BNToDS(bigNumber, decimals) {
        return DecimalString(utils.formatUnits(bigNumber, decimals || 18));
    }
    /* End region of big number conversions */
    /* Conversion from big number string to big number and decimal string */
    BNSToBN(bigNumberString) {
        return BigNumber.from(bigNumberString);
    }
    BNSToDS(bigNumberString, decimals) {
        const valueBigNumber = BigNumber.from(bigNumberString);
        return DecimalString(utils.formatUnits(valueBigNumber, decimals || 18));
    }
};
BigNumberUtils = __decorate([
    injectable()
], BigNumberUtils);
export { BigNumberUtils };
//# sourceMappingURL=BigNumberUtils.js.map